// paravelview.h
//
// A Qt-based launcher for X11Vnc
//
//   (C) Copyright 2015-2021 Fred Gleason <fredg@paravelsystems.com>
//
//   All Rights Reserved.
//

#ifndef PARAVELVIEW_H
#define PARAVELVIEW_H

#include <QProcess>
#include <QLineEdit>
#include <QLabel>
#include <QPushButton>
#include <QSpinBox>
#include <QTimer>
#include <QWidget>

#define PARAVELVIEW_USAGE ""

class MainWidget : public QWidget
{
  Q_OBJECT
 public:
  MainWidget(QWidget *parent=0);
  QSize sizeHint() const;
  QSizePolicy sizePolicy() const;

 private slots:
  void hostnameChangedData(const QString &str);
  void connectData();
  void vncFinishedData(int exit_code,QProcess::ExitStatus exit_status);
  void cleanupProcessData();

 protected:
  void closeEvent(QCloseEvent *e);
  void resizeEvent(QResizeEvent *e);

 private:
  QLabel *view_hostname_label;
  QLineEdit *view_hostname_edit;
  QLabel *view_port_label;
  QSpinBox *view_port_spin;
  QLabel *view_logo_label;
  QLabel *view_phone_label_label;
  QLabel *view_phone_value_label;
  QLabel *view_email_label_label;
  QLabel *view_email_value_label;
  QPushButton *view_connect_button;
  QProcess *view_process;
  QTimer *view_process_timer;
  QString view_display;
  QString view_homedir;
};


#endif  // PARAVELVIEW_H
